﻿using Syncfusion.UI.Xaml.Charts;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FastScatterSelection
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<FastScatterBitmapSeries> selectedSegementSeries { get; set; }
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = this;
            DataGenerator viewModel = new DataGenerator();
            ObservableCollection<Data> collection = viewModel.GenerateData();
            series1.ItemsSource = collection;
            series2.ItemsSource = collection;
            series3.ItemsSource = collection;
        }

        private void fastScatter_SelectionChanging(object sender, Syncfusion.UI.Xaml.Charts.ChartSelectionChangingEventArgs e)
        {
           
                foreach (var series in fastScatter.Series)
                {                 
                    if (series != e.SelectedSegment.Series as FastScatterBitmapSeries)
                    {
                        (series as FastScatterBitmapSeries).SelectedIndex = -1;
                      
                    }
                }
           
        }
    }

    public class DataGenerator
    {
        public int DataCount = 25;

        private Random randomNumber;

        public DataGenerator()
        {
            randomNumber = new Random();
        }

        public ObservableCollection<Data> GenerateData()
        {
            ObservableCollection<Data> datas = new ObservableCollection<Data>();

            DateTime date = new DateTime(2000, 1, 1);
            double value1 = 100;
            double value2 = 400;
            double value3 = 700;
            for (int i = 0; i < this.DataCount; i++)
            {
                datas.Add(new Data(date, value1 , value2 , value3));
                date = date.Add(TimeSpan.FromDays(5));

                if (randomNumber.NextDouble() > .5)
                {
                    value1 += randomNumber.NextDouble();
                    value2 += randomNumber.NextDouble();
                    value3 += randomNumber.NextDouble();
                }
                else
                {
                    value1 -= randomNumber.NextDouble();
                    value2 -= randomNumber.NextDouble();
                    value3 -= randomNumber.NextDouble();
                }
            }

            return datas;
        }
    }

    public class Data
    {
        public Data(DateTime date, double value1 , double value2 , double value3)
        {
            Date = date;
            Value1 = value1;
            Value2 = value2;
            Value3 = value3;
        }

        public DateTime Date
        {
            get;
            set;
        }

        public double Value1
        {
            get;
            set;
        }

        public double Value2
        {
            get;
            set;
        }

        public double Value3
        {
            get;
            set;
        }
    }
}

